Purse/pwd.sh

203 lines
3.8 KiB
Bash
Raw Normal View History

2015-07-03 18:59:27 +00:00
#!/usr/bin/env bash
2015-07-02 02:03:55 +00:00
#
# Script for managing passwords in a symmetrically encrypted file using GnuPG.
2015-07-02 02:03:55 +00:00
set -o errtrace
2015-07-02 02:03:55 +00:00
set -o nounset
set -o pipefail
2015-07-02 02:03:55 +00:00
2015-07-07 01:00:13 +00:00
gpg=$(command -v gpg || command -v gpg2)
2015-07-03 06:27:53 +00:00
safe=${PWDSH_SAFE:=pwd.sh.safe}
2015-07-02 02:03:55 +00:00
fail () {
# Print an error message and exit.
2015-07-02 02:03:55 +00:00
tput setaf 1 ; echo "Error: ${1}" ; tput sgr0
exit 1
}
2015-07-02 02:03:55 +00:00
get_pass () {
# Prompt for a password.
2015-07-02 02:03:55 +00:00
2015-07-03 13:07:54 +00:00
password=''
prompt="${1}"
while IFS= read -p "${prompt}" -r -s -n 1 char ; do
2015-07-03 13:07:54 +00:00
if [[ ${char} == $'\0' ]] ; then
break
2015-07-03 17:05:06 +00:00
elif [[ ${char} == $'\177' ]] ; then
if [[ -z "${password}" ]] ; then
prompt=""
2015-07-03 13:07:54 +00:00
else
prompt=$'\b \b'
password="${password%?}"
2015-07-02 02:03:55 +00:00
fi
2015-07-03 13:07:54 +00:00
else
2015-07-03 17:05:06 +00:00
prompt="*"
password+="${char}"
2015-07-03 13:07:54 +00:00
fi
2015-07-02 02:03:55 +00:00
done
2015-07-03 17:05:06 +00:00
if [[ -z ${password} ]] ; then
fail "No password provided"
fi
2015-07-02 02:03:55 +00:00
}
decrypt () {
# Decrypt with a password.
2015-07-02 02:03:55 +00:00
echo "${1}" | ${gpg} \
2015-07-02 02:03:55 +00:00
--decrypt --armor --batch \
--passphrase-fd 0 "${2}" 2>/dev/null
2015-07-02 02:03:55 +00:00
}
encrypt () {
# Encrypt with a password.
2015-07-02 02:03:55 +00:00
${gpg} \
--symmetric --armor --batch --yes \
--passphrase-fd 3 \
--output "${2}" "${3}" 3< <(echo "${1}")
2015-07-02 02:03:55 +00:00
}
read_pass () {
# Read a password from safe.
2015-07-02 02:03:55 +00:00
if [[ -z "${2+x}" ]] ; then
read -p "
Username to read? (default: all) " username
else
username="${2}"
fi
2015-07-03 04:16:37 +00:00
if [[ -z ${username} || ${username} == "all" ]] ; then
username=""
fi
2015-07-03 21:03:26 +00:00
if [[ ! -s ${safe} ]] ; then
fail "No passwords found"
2015-07-02 02:03:55 +00:00
else
2015-07-03 21:03:26 +00:00
get_pass "
Enter password to unlock ${safe}: "
printf "\n\n"
2015-07-03 04:16:37 +00:00
decrypt ${password} ${safe} | grep " ${username}" || fail "Decryption failed"
2015-07-02 02:03:55 +00:00
fi
}
gen_pass () {
# Generate a password.
2015-07-02 02:03:55 +00:00
2015-07-03 21:03:26 +00:00
len=50
2015-07-03 15:49:38 +00:00
max=100
2015-07-03 21:03:26 +00:00
read -p "
Password length? (default: ${len}, max: ${max}) " length
2015-07-02 02:31:38 +00:00
if [[ ${length} =~ ^[0-9]+$ ]] ; then
len=${length}
2015-07-02 02:03:55 +00:00
fi
2015-07-03 04:29:12 +00:00
# base64: 4 characters for every 3 bytes
2015-07-03 15:49:38 +00:00
${gpg} --gen-random -a 0 "$((${max} * 3/4))" | cut -c -${len}
2015-07-02 02:31:38 +00:00
}
write_pass () {
# Write a password in safe.
2015-07-02 02:03:55 +00:00
# If no password provided, clear the entry by writing an empty line.
if [[ -z ${userpass+x} ]] ; then
new_entry=" "
else
new_entry="${userpass} ${username}"
2015-07-02 02:31:38 +00:00
fi
2015-07-03 21:03:26 +00:00
get_pass "
Enter password to unlock ${safe}: " ; echo
# If safe exists, decrypt it and filter out username, or bail on error.
# If successful, append new entry, or blank line.
# Filter out any blank lines.
# Finally, encrypt it all to a new safe file, or fail.
# If successful, update to new safe file.
( if [[ -f ${safe} ]] ; then
decrypt ${password} ${safe} | \
grep -v -e " ${username}$" || return
fi ; \
echo "${new_entry}") | \
grep -v -e "^[[:space:]]*$" | \
encrypt ${password} ${safe}.new - || fail "Write to safe failed"
mv ${safe}.new ${safe}
2015-07-02 02:03:55 +00:00
}
create_username () {
# Create a new username and password.
2015-07-02 02:03:55 +00:00
if [[ -z "${2+x}" ]] ; then
read -p "
2015-07-03 21:03:26 +00:00
Username: " username
read -p "
2015-07-03 21:03:26 +00:00
Generate password? (y/n, default: y) " rand_pass
else
rand_pass=""
username="${2}"
fi
2015-07-03 21:03:26 +00:00
if [[ "${rand_pass}" =~ ^([nN][oO]|[nN])$ ]]; then
2015-07-03 21:03:26 +00:00
get_pass "
Enter password for \"${username}\": " ; echo
userpass=$password
2015-07-02 02:03:55 +00:00
else
userpass=$(gen_pass)
2015-07-03 21:03:26 +00:00
echo "
Password: ${userpass}"
2015-07-02 02:03:55 +00:00
fi
}
sanity_check () {
# Make sure required programs are installed and can be executed.
2015-07-02 02:03:55 +00:00
if [[ -z ${gpg} && ! -x ${gpg} ]] ; then
fail "GnuPG is not available"
2015-07-02 02:03:55 +00:00
fi
}
sanity_check
2015-07-02 02:03:55 +00:00
if [[ -z "${1+x}" ]] ; then
read -n 1 -p "
Read, write, or delete password? (r/w/d, default: r) " action
2015-07-27 11:58:43 +00:00
printf "\n"
else
action="${1}"
2015-07-27 11:58:43 +00:00
fi
if [[ "${action}" =~ ^([wW])$ ]] ; then
create_username "$@"
write_pass
elif [[ "${action}" =~ ^([dD])$ ]] ; then
if [[ -z "${2+x}" ]] ; then
read -p "
Username to delete? " username
else
username="${2}"
fi
write_pass
else
read_pass "$@"
fi
2015-07-02 02:03:55 +00:00
2015-07-03 21:03:26 +00:00
tput setaf 2 ; echo "
Done" ; tput sgr0